#include<reg51.h>
#include<intrins.h>

typedef unsigned char  U8;       /* defined for unsigned 8-bits integer variable 	  ޷8λͱ  */
typedef signed   char  S8;       /* defined for signed 8-bits integer variable		  з8λͱ  */
typedef unsigned int   U16;      /* defined for unsigned 16-bits integer variable 	  ޷16λͱ */
typedef signed   int   S16;      /* defined for signed 16-bits integer variable 	  з16λͱ */
typedef unsigned long  U32;      /* defined for unsigned 32-bits integer variable 	  ޷32λͱ */
typedef signed   long  S32;      /* defined for signed 32-bits integer variable 	  з32λͱ */
typedef float          F32;      /* single precision floating point variable (32bits) ȸ32λȣ */
typedef double         F64;      /* double precision floating point variable (64bits) ˫ȸ64λȣ */

sbit LCD_RS = P0^7;             
sbit LCD_RW = P0^6;
sbit LCD_EN = P0^5;

sbit LED = P1^0;



#define Data P2
#define   Data_0_time    4

//ӿ ޸






/*****************
ƣdelay()
ܣʱ
******************/
void delay1(U16 i)
{
	U16 j,k; 	
	for(j=i;j>0;j--)
	for(k=125;k>0;k--);
}

 void DelayUs2x(U8 t)
{   
 	while(--t);
}

void DelayMs(U8 t)
{
     
    while(t--)
    {
     //ʱ1mS
       DelayUs2x(245);
       DelayUs2x(245);
    } 
}

void Delay(U16 j)
{     
	 U8 i;
	 for(;j>0;j--)
	 { 	
		for(i=0;i<27;i++);

	 }
}
void  Delay_10us(void)
{
   U8 i;
   i--;
   i--;
   i--;
   i--;
   i--;
   i--;
}


/*****************
ƣbit lcd_busy()
ܣLCDæ״̬ 
ֵ  
ֵ  
******************/
bit lcd_busy()
 {                          
    bit result;
    LCD_RS = 0;
    LCD_EN = 1;
    delay1(1);
    result = (bit)(Data&0x80);
    LCD_EN = 0;
    return(result); 
 }
/*****************
ƣvoid LCD1602_WriteCmd(unsigned char cmd)
ܣдָݵLCD 
ֵ  ָ
ֵ  
******************/
void LCD1602_WriteCmd(unsigned char cmd)
{                          
    LCD_RS = 0;
    LCD_EN = 0;
    delay1(1); 
    Data = cmd;
    delay1(5);
    LCD_EN = 1;
    delay1(5);
    LCD_EN = 0; 
    delay1(10);
}


/*****************
ƣvoid LCD1602_WriteData(unsigned char dat)
ܣдʾݵLCD  
ֵ  
ֵ  
******************/
void LCD1602_WriteData(U8 dat)
{                          
    LCD_RS = 1;
    LCD_EN = 0;
    Data = dat;
    delay1(1);
    LCD_EN = 1;
    delay1(1);
    LCD_EN = 0; 
    delay1(10);
}

/*****************
ƣvoid lcd_init(void)
ܣLCD1602ʼ  
ֵ  
ֵ  
******************/
void lcd_init(void)
{    
    LCD_RW = 0;
    delay1(15);   
    LCD1602_WriteCmd(0x01);      //LCDʾ            
    LCD1602_WriteCmd(0x38);      //16*2ʾ5*78λ
    delay1(5);
    LCD1602_WriteCmd(0x38);         
    delay1(5);
    LCD1602_WriteCmd(0x38);         
    delay1(5);

    LCD1602_WriteCmd(0x0c);      //ʾʾ  
    delay1(5);

    LCD1602_WriteCmd(0x01);      //LCDʾ
    delay1(5);
}

/*****************
ƣvoid LCD1602_WriteChar(unsigned char x,unsigned char y,unsigned char Dat)
ܣдַָ  
ֵ  x: (ȡ0~1) y: (ȡ0~15) DatΪҪʾ
ֵ  
******************/
void LCD1602_WriteChar(U8 x,U8 y,U8 Dat)
{
  if(x==0)
  {
    LCD1602_WriteCmd(0x80+y);
    LCD1602_WriteData(Dat);
    delay1(5);
  }
  if(x != 0)
  {
    LCD1602_WriteCmd(0x80+0x40+y);
    LCD1602_WriteData(Dat);
    delay1(5);
  }
}
/*****************
ƣvoid LCD1602_WriteChar(unsigned char x,unsigned char y,unsigned char Dat)
ܣдַָ    (x,y)Ϊ׸ַʾλ  
ֵ  x: (ȡ0~1) y: (ȡ0~15) DatΪҪʾ
ֵ  
******************/
void LCD1602_WriteString(U8 x,U8 y,U8 *String)
{
  U8 i;
  for(i=0;String[i]!='\0';i++)
  {
    LCD1602_WriteChar(x,y++,String[i]);
  }
}

void init(void)
{
    TMOD = 0x20;	  //ʱT1ʹùʽ2
	TH1 = 253;        // óֵ
	TL1 = 253;
	TR1 = 1;          // ʼʱ
	SCON = 0x50;	  //ʽ19600bps   
	ES = 1;
	EA = 1;           // ж   

}


void main(void)
{
	int a;
	lcd_init();	
	init();	
	
	while (1) 
	 { 
	   LCD1602_WriteString(0,0,"GangBanHou:");
	   LCD1602_WriteString(1,3,"mm");
	   LCD1602_WriteChar(1,0,'f');
	   a++;
	   DelayMs(500);
	   LCD1602_WriteChar(1,1,a+'0');
	  
 	}
}

